diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 5c89f61b9..8ea3fa761 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -236,10 +236,10 @@ public final class GameSettings {
                 return percent + "%";
             }
         }));
-    public static final @NotNull OptionFloat CLOUD_RENDER_DISTANCE = register(new OptionFloat("cloudRenderDistance", 1f)
+    public static final @NotNull OptionFloat CLOUD_RENDER_DISTANCE = register(new OptionFloat("cloudRenderDistance", 2f)
         .withDisplayStringProvider((mc, i18n, option) -> {
             int percent = MathHelper.round(option.value * 100.0f);
-            if (percent == 100) {
+            if (percent == 200) {
                 return i18n.translateKey("options.cloudRenderDistance.default");
             } else {
                 return percent + "%";
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 266ea7636..b1ca717e0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -44,4 +44,8 @@ public abstract class BlockModel<T extends BlockLogic> {
     public boolean isRetro() {
         return Minecraft.getMinecraft().currentWorld != null && Minecraft.getMinecraft().currentWorld.getWorldType().hasTag(WorldTypeTags.RETRO);
     }
+
+    public long getPositionalSeed(@NotNull TilePosc tilePos) {
+        return tilePos.x() * 374761393L + tilePos.y() * 668265263L + tilePos.z() * 968290493L;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index b05d1763a..0627c4fa7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -230,20 +230,12 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericFullyRotatable<>(Blocks.BONESHALE,
                 loadDataModel("minecraft:block/bone_shale")));
 
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_FLOWING)
-            .onRenderLayer(1)
-            .setAllTextures("minecraft:block/water_flowing")
-            .setTex("minecraft:block/water_still", Side.TOP));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_STILL)
-            .onRenderLayer(1)
-            .setTex("minecraft:block/water_still", Side.TOP, Side.BOTTOM)
-            .setTex("minecraft:block/water_flowing", Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_FLOWING)
-            .setAllTextures("minecraft:block/lava_flowing")
-            .setTex("minecraft:block/lava_still", Side.TOP));
-        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_STILL)
-            .setTex("minecraft:block/lava_still", Side.TOP, Side.BOTTOM)
-            .setTex("minecraft:block/lava_flowing", Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_FLOWING, "minecraft:block/water_still", "minecraft:block/water_flowing")
+            .onRenderLayer(1));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_STILL, "minecraft:block/water_still", "minecraft:block/water_flowing")
+            .onRenderLayer(1));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_FLOWING, "minecraft:block/lava_still", "minecraft:block/lava_flowing"));
+        addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_STILL, "minecraft:block/lava_still", "minecraft:block/lava_flowing"));
 
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_OAK, loadDataModel("minecraft:block/log/oak")));
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_PINE, loadDataModel("minecraft:block/log/pine")));
@@ -339,10 +331,10 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_DIAMOND_GRANITE, loadDataModel("minecraft:block/ore/diamond/granite")));
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_DIAMOND_PERMAFROST, loadDataModel("minecraft:block/ore/diamond/permafrost")));
 
-        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS, loadDataModel("minecraft:block/rubyglass/block")));
-        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_PURE, loadDataModel("minecraft:block/rubyglass/block_pure")).forceCullSelf(true));
+        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_COLUMN, loadDataModel("minecraft:block/rubyglass/column")));
+        addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_NODE, loadDataModel("minecraft:block/rubyglass/node")));
+        addDispatch(new BlockModelGeneric<>(Blocks.BLOCK_RUBYGLASS, loadDataModel("minecraft:block/rubyglass/block")).forceCullSelf(true));
         addDispatch(new BlockModelCrystalBud<>(Blocks.RUBYGLASS_SPROUT, loadDataModel("minecraft:block/rubyglass/sprout")));
-        addDispatch(new BlockModelGenericRubyglassBud<>(Blocks.RUBYGLASS_BUD));
         addDispatch(new BlockModelGeneric<>(Blocks.RUBYGLASS_CIRCUIT, loadDataModel("minecraft:block/rubyglass/circuit")));
 
         addDispatch(new BlockModelGeneric<>(Blocks.ORE_NETHERCOAL_NETHERRACK, loadDataModel("minecraft:block/ore/nethercoal/netherrack")));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 1d7e5ed30..bae1ed67b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -3,23 +3,47 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFluid;
+import net.minecraft.core.block.BlockLogicFluidFlowing;
+import net.minecraft.core.block.FluidWater;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
 import org.joml.Vector3d;
 import org.joml.primitives.AABBdc;
 
+import java.util.Random;
+
 public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStandard<T> {
-    public BlockModelFluid(Block<T> block) {
+    public final Random random = new Random();
+    public final IconCoordinate flowing;
+    public final IconCoordinate still;
+    public final IconCoordinate bubbles;
+
+    public BlockModelFluid(Block<T> block, @NotNull String still, @NotNull String flowing) {
         super(block);
+        this.still = TextureRegistry.getTexture(still);
+        this.flowing = TextureRegistry.getTexture(flowing);
+        this.bubbles = TextureRegistry.getTexture("minecraft:block/water_overlay_boiling");
+
+        if (block.getLogic() instanceof BlockLogicFluidFlowing) {
+            setAllTextures(this.flowing);
+            setTex(this.still, Side.TOP);
+        } else {
+            setTex(this.still, Side.TOP, Side.BOTTOM);
+            setTex(this.flowing, Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST);
+        }
     }
 
     private final @NotNull Vector3d br = new Vector3d();
@@ -32,7 +56,8 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
 
     @Override
     public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
-        tessellator.setColor1i(BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0));
+        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
+        tessellator.setColor1i(color);
 
         TilePos queryPos = new TilePos();
         final int x = tilePos.x();
@@ -72,7 +97,7 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             byte lightUp = this.block.getLightIndex(worldSource, tilePos.up(queryPos));
 
             tessellator.setLightmapCoord1i(LightIndexHelper.max(light, lightUp));
-            if (tex.namespaceId.toString().contains("_flowing")) {
+            if (tex == this.flowing) {
                 float cos = Math.cos(-rotation + Math.PI_OVER_2_f);
                 float sin = Math.sin(-rotation + Math.PI_OVER_2_f);
 
@@ -108,6 +133,49 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 tessellator.addVertexWithUV(x, (float) y + hs, z + 1, tex.getIconUMax(), tex.getIconVMax());
                 tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, tex.getIconUMax(), tex.getIconVMin());
                 tessellator.addVertexWithUV(x + 1, (float) y + he, z, tex.getIconUMin(), tex.getIconVMin());
+
+                if (worldSource.getWorldType().hasTag(WorldTypeTags.NETHER) && this.block.getLogic().fluid instanceof FluidWater) {
+                    tessellator.setColorOpaque3i(
+                        ((Color.redFromInt(color) * 3) / 4) + (255/4),
+                        ((Color.greenFromInt(color) * 3) / 4) + (255/4),
+                        ((Color.blueFromInt(color) * 3) / 4) + (255/4));
+
+                    random.setSeed(getPositionalSeed(tilePos));
+
+                    switch (random.nextInt(4)) {
+                        case 0: {
+                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            break;
+                        }
+                        case 1: {
+                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            break;
+                        }
+                        case 2: {
+                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            break;
+                        }
+                        case 3: {
+                            tessellator.addVertexWithUV(x, (float) y + h, z, this.bubbles.getIconUMax(), this.bubbles.getIconVMax());
+                            tessellator.addVertexWithUV(x, (float) y + hs, z + 1, this.bubbles.getIconUMax(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, this.bubbles.getIconUMin(), this.bubbles.getIconVMin());
+                            tessellator.addVertexWithUV(x + 1, (float) y + he, z, this.bubbles.getIconUMin(), this.bubbles.getIconVMax());
+                            break;
+                        }
+                    }
+
+
+                    tessellator.setColor1i(color);
+                }
             }
 
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
index a2f9296e2..f5eb59693 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
@@ -26,7 +26,5 @@ public class BlockModelGenericMatcher<T extends BlockLogic> extends BlockModelGe
         return this.models[this.random.nextInt(4)];
     }
 
-    public long getPositionalSeed(@NotNull TilePosc tilePos) {
-        return tilePos.x() * 374761393L + tilePos.y() * 668265263L + tilePos.z() * 968290493L;
-    }
+
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index d134b8853..546314a3c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -424,8 +424,8 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new ItemModelStandard(Items.FOOD_VENISON_RAW, "minecraft"));
         addDispatch(new ItemModelStandard(Items.FOOD_VENISON_COOKED, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.RUBYGLASS_CRYSTAL_CRACKED, "minecraft"));
-        addDispatch(new ItemModelStandard(Items.RUBYGLASS_CRYSTAL_PURE, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.RUBYGLASS_DUST, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.RUBYGLASS_CRYSTAL, "minecraft"));
 
         addDispatch(new ItemModelStandard(Items.DOUGH, "minecraft"));
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
new file mode 100644
index 000000000..b36d3fe5f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
@@ -0,0 +1,69 @@
+package net.minecraft.client.render.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.joml.primitives.AABBd;
+
+public class ParticleBubbleBoiling extends Particle {
+    private float sinTimer = 0;
+    private boolean isReversed = false;
+    private final boolean needsWater;
+//    private final AABBd aabbd = new AABBd();
+    private final TilePos qpos = new TilePos();
+
+    public ParticleBubbleBoiling(World world, double x, double y, double z, double xa, double ya, double za, boolean needsWater) {
+        super(world, x, y, z, xa, ya, za);
+        this.needsWater = needsWater;
+        this.rCol = 1.0F;
+        this.gCol = 1.0F;
+        this.bCol = 1.0F;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/bubble_boiling");
+        this.size = this.size * (random.nextFloat() * 0.7F + 0.3F);
+        this.xd = xa * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
+        this.yd = ya * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
+        this.zd = za * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
+        this.lifetime = (int) (16D / (Math.random() * 0.4D + 0.1D));
+
+        this.isReversed = random.nextInt(2) == 0;
+    }
+
+    @Override
+    public void tick() {
+        this.sinTimer++;
+        if (this.sinTimer > 100) {
+            this.sinTimer = 0;
+        }
+
+        this.cachedLightmapCoord = calcLightIndex(1f);
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        final double expand = 0.05;
+//        this.aabbd.setMin(this.x - expand, this.y - expand, this.z - expand).setMax(this.x + expand, this.y, this.z + expand);
+//        boolean inWater = this.world.isAABBInMaterial(this.qpos, Materials.WATER);
+        boolean inWater = this.world.getBlockMaterial(this.qpos.set((int) this.x, (int) (this.y), (int) this.z)) == Materials.WATER;
+        if (inWater) {
+            this.yd = 0.20D;
+
+            this.xd = ((MathHelper.sin(this.sinTimer * 0.95f)) / 30f) * (this.isReversed ? -1 : 1);
+            this.zd = ((MathHelper.cos(this.sinTimer * 0.95f)) / 30f) * (this.isReversed ? -1 : 1);
+        } else {
+            this.yd = MathHelper.clamp(this.yd, -0.05, 0.005);
+        }
+        this.move(this.xd, this.yd, this.zd);
+        this.xd *= 0.85D;
+        this.yd *= 0.85D;
+        this.zd *= 0.85D;
+        if (this.needsWater && !inWater) {
+            this.lifetime = MathHelper.clamp(this.lifetime, 0, 8);
+        }
+        if (this.lifetime-- <= 0) {
+            remove();
+            world.spawnParticle("smoke", x, y, z, 0.0D, 0.0D, 0.0D, 1);
+        }
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index ec06a71e3..955c11139 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -50,6 +50,12 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
                 return new ParticleBubble(world, x, y, z, motionX, motionY, motionZ, true);
             }
         });
+        addDispatch("bubbleboiling", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleBubbleBoiling(world, x, y, z, motionX, motionY, motionZ, true);
+            }
+        });
         addDispatch("smoke", new ParticleEntry() {
             @Override
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
index e4c1bf876..e7f023344 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -25,7 +25,7 @@ public final class Shaders {
     public static final @NotNull Shader WORLD = register("world", new Shader());
     public static final @NotNull Shader AURORA = register("aurora", new Shader());
     public static final @NotNull Shader ENTITY = register("entity", new Shader());
-    public static final @NotNull Shader TERRAIN = register("terrain", new ShaderGeometry());
+    public static final @NotNull Shader TERRAIN = register("terrain", new Shader());
     public static final @NotNull Shader ITEM = register("item", new Shader());
     public static final @NotNull Shader INTERFACE = register("interface", new Shader());
     public static final @NotNull Shader COLOR = register("color", new Shader());
